/*
 * 
 * $Copyright
 * Copyright 1993, 1994, 1995  Intel Corporation
 * INTEL CONFIDENTIAL
 * The technical data and computer software contained herein are subject
 * to the copyright notices; trademarks; and use and disclosure
 * restrictions identified in the file located in /etc/copyright on
 * this system.
 * Copyright$
 * 
 */
 
/*
 * @OSF_FREE_COPYRIGHT@
 */
/* 
 * Mach Operating System
 * Copyright (c) 1991,1990,1989 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS  "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 * 
 * Carnegie Mellon requests users of this software to return to
 * 
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 * 
 * any improvements or extensions that they make and grant Carnegie the
 * rights to redistribute these changes.
 */
/*
 *  HISTORY
 * $Log: atoh.c,v $
 * Revision 1.2  1994/11/19  02:15:23  mtm
 * Copyright additions/changes
 *
 * Revision 1.1  1993/05/03  23:53:35  stans
 * Initial revision
 *
 * Revision 1.2  1992/05/12  14:36:38  devrcs
 * 	Created for OSF/1 MK
 * 	[1992/05/05  01:08:01  condict]
 *
 * Revision 2.3  92/02/16  15:24:52  rpd
 * 	Moved from libcs to libcmucs.
 * 
 * Revision 2.2  92/01/22  23:13:06  rpd
 * 	Moved to libcs from libmach.
 * 	[92/01/19            rpd]
 * 
 * Revision 2.2  91/04/11  11:07:11  mrt
 * 	Copied from libcs
 * 
 * Revision 1.2  90/12/11  17:50:07  mja
 * 	Add copyright/disclaimer for distribution.
 * 
 * Revision 0.0  79/11/20            sas
 * 	Created for VAX.
 * 	[79/11/20            sas]
 * 
 * $EndLog$
 */
/*
 *  File:	atoh  --  convert ascii to hexidecimal
 *  Author: 	Steven Shafer, Carnegie Mellon University
 *  Date:	Nov. 1979
 *
 *  Usage:  i = atoh (string);
 *	unsigned int i;
 *	char *string;
 *
 *  Atoh converts the value contained in "string" into an
 *  unsigned integer, assuming that the value represents
 *  a hexidecimal number.
 *
 */

unsigned int atoh(ap)
char *ap;
{
	register char *p;
	register unsigned int n;
	register int digit,lcase;

	p = ap;
	n = 0;
	while(*p == ' ' || *p == '	')
		p++;
	while ((digit = (*p >= '0' && *p <= '9')) ||
		(lcase = (*p >= 'a' && *p <= 'f')) ||
		(*p >= 'A' && *p <= 'F')) {
		n *= 16;
		if (digit)	n += *p++ - '0';
		else if (lcase)	n += 10 + (*p++ - 'a');
		else		n += 10 + (*p++ - 'A');
	}
	return(n);
}
